# Copyright 2016-2017 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


from .base_task import ContainerBaseTask
from libertine import utils


class SearchTask(ContainerBaseTask):
    def __init__(self, container_id, cache, query, config, monitor, client):
        super().__init__(lock=None, container_id=container_id, config=config, monitor=monitor, client=client)
        self._cache = cache
        self._query = query

    def _run(self):
        if self._cache:
            self._data(str(self._cache.search(self._query)))
        else:
            container = LibertineContainer(self._container, self._config, self._client)
            if container.search_package_cache(self._query) is not 0:
                self._error("Search for '{}' in container '{}' exited with non-zero status"
                           .format(self._container, self._query))
